一.引入

编写程序时会有各种各样的错误,例如

【学懂Java】(五)异常处理_自定义异常

该程序在被除数为0的时候,就会不正确。我们可以这样解决

【学懂Java】(五)异常处理_异常处理机制_02

但是这样也有弊端:

  • 代码臃肿
  • 程序员要花很大精力“堵漏洞”
  • 程序员很难堵住所有“漏洞”

因此需要引入异常机制

二.异常处理机制

1.注意

  • Java编程语言使用异常处理机制为程序提供了错误处理的能力

【学懂Java】(五)异常处理_自定义异常_03

  • Java的异常处理是通过5个关键字来实现的:try、catch、finally、throw、throws

【学懂Java】(五)异常处理_异常处理机制_04

  • 程序在运行过程中如果出现了问题,会导致后面的代码无法正常执行,而使用异常机制之后,可以对异常情况进行处理同时后续的代码会继续执行,不会中断整个程序
  • 在异常的处理过程中,不要只是简单的输出错误,要尽可能的讲详细的异常信息进行输出e.printStackTrace():打印异常的堆栈信息,可以从异常信息的最后一行开始追踪,寻找自己编写的java类

2.捕获异常

try-catch

try{代码逻辑}catch(Exception e){异常处理逻辑}

try{代码逻辑}catch(具体的异常Exception e){异常处理逻辑}catch(具体的异常):

  • 可以针对每一种具体的异常做相应的更丰富的处理
  • 注意:当使用多重的catch的时候一定要注意相关异常的顺序,将子类放在最前面的catch,父类放在后面的catch

使用try-catch块捕获异常,分为三种情况:

  1. 正常执行,只执行try中的代码
  2. 遇到异常情况,会处理try中异常代码之前的逻辑,后面的逻辑不会执行,最后会执行catch中的代码
  3. 使用多重catch的时候,会遇到异常子类不匹配的情况,此时依然会报错,因此建议在catch的最后将所有的异常的父类写上

【学懂Java】(五)异常处理_自定义异常_05

【学懂Java】(五)异常处理_自定义异常_06

【学懂Java】(五)异常处理_自定义异常_07

我们将之前的例子改进一下

public class TestException {
public static void main(String[] args) {
Scanner in = new Scanner(System.in);
try {
System.out.print("请输入被除数:");
int num1 = in.nextInt();
System.out.print("请输入除数:");
int num2 = in.nextInt();
System.out.println(String.format("%d / %d = %d",
num1, num2, num1 / num2));
System.out.println("前面没有出现异常");
/*}catch(Exception e){
System.out.println("出现异常");
e.printStackTrace();//输出相关异常信息,比如行数
System.out.println(e.getMessage());
}*/
}catch(ArithmeticException e){
System.out.println("数学异常,除数不能是0");
e.printStackTrace();
}catch (InputMismatchException e){
System.out.println("输入的参数值类型不匹配");
e.printStackTrace();
}catch (NullPointerException e){
System.out.println("空指针异常");
e.printStackTrace();
}
System.out.println("感谢使用本程序");
}
}

【学懂Java】(五)异常处理_自定义异常_08

【学懂Java】(五)异常处理_异常处理机制_09

try-catch-finally

在程序运行过程中,如果处理异常的部分包含finally的处理,那么无论代码是否发生异常,finally中的代码总会执行

finally包含哪些处理逻辑?

  1. IO流的关闭操作一般设置在finally中
  2. 数据库的连接关闭操作设置在finally中
public class FinallyDemo {
public static void main(String[] args) {
}
public static void test(){
try{
System.out.println(1/10);
return;
}catch (Exception e){
e.printStackTrace();
return;
}finally {
System.out.println("我是finally");
return;
}
}
}

3.声明异常

throws:声明异常

在异常情况出现的时候,可以使用try...catch...finally的方式对异常进行处理,除此之外,可以将异常向外抛出,由外部进行处理

1、在方法调用过程中,可以存在N多个方法之间的调用,此时假如每个方法中都包含了异常情况

  • 那么就需要在每个方法中都进行try。。catch,另外一种比较简单的方式,就是在方法的最外层调用处理一次即可使用throws的方法,对所有执行过程中的所有方法出现的异常进行统一集中处理

2、如何判断是使用throws还是使用try...catch..

  • 最稳妥的方式是在每个方法中都进行异常的处理
  • 偷懒的方式是判断在整个调用的过程中,外层的调用方法是否有对异常的处理,如果有,直接使用throws,如果没有那么就要使用try...catch...
public class Excepton2 {
public static void main(String[] args) {
try {
show();
} catch (Exception e) {
e.printStackTrace();
}
System.out.println("ll");
}

public static void test1() throws Exception{
System.out.println(1/0);
}
public static void test2() throws Exception {
test1();
System.out.println(100/0);
}
public static void test3() throws Exception{
test2();
}
public static void test4() throws Exception{
test3();
}
}

4.抛出异常

throw:抛出异常

public class Excepton2 {
public static void main(String[] args) {
try {
show();
} catch (Exception e) {
e.printStackTrace();
}
System.out.println("hehe");
}

public static void show() throws Exception{
String gender = "12";
if (gender.equals("man")){
System.out.println("man");
}else if(gender.equals("woman")){
System.out.println("woman");
}else{
throw new Exception("性别出现错误");
}
}

}

自定义异常

在java的api中提供了非常丰富的异常类,但是在某些情况下不太满足我们的需求,此时需要自定义异常

步骤:

  1. 继承Exception类
  2. 自定义实现构造方法
  3. 需要使用的时候,使用throw new 自定义异常的名称;

什么时候需要自定义异常?

一般情况下不需要,但是在公司要求明确,或者要求异常格式规范统一的时候是必须要自己实现的

public class GenderException extends Exception {
public GenderException(){
System.out.println("性别异常");
}
public GenderException(String msg){
System.out.println(msg);
}
}
public class Excepton2 {
public static void main(String[] args) {
try {
show();
} catch (GenderException e) {
e.printStackTrace();
}
System.out.println("hehe");
}

public static void show() throws GenderException{
String gender = "12";
if (gender.equals("man")){
System.out.println("man");
}else if(gender.equals("woman")){
System.out.println("woman");
}else{
// throw new Exception("性别出现错误");
throw new GenderException("gender is wrong");
}
}
}

5.异常的分类

【学懂Java】(五)异常处理_自定义异常_10